      program hmo

c Hueckel MO Program v.1.2  FORTRAN 77 version
c                                written by H. Kihara
c
c    o͕͂Wo͂𗘗p܂B
c
      character*40 title
      common g(30,30), v(30,30), ib(30), jb(30), na, nb, np, nh
  
c     g : iNs  v : ŗLxNg
c     ib, jb  ΁iאڍsj

      write(*,100)
      read(*,*) title
      write(*,110) title
      read(*,*) na, nb, np, nh
      write(*,120) na, nb

      call secdet()                ! iNs̑gݗ
      if (nh.gt.0) then
        call hetero()              ! wej܂ޏꍇ
      end if

      call diag()                  ! Rr@ɂΊp
      call incre()                 ! ŗLl̏ɕוς
      call pout()                  ! ʂ̈

  100 format(' ***  Hueckel Molecular Orbital Calculation  ***'/)
  110 format(1x,a40)
  120 format(1x,i4,' Atoms     ',i4,' Bonds')
      end

      subroutine secdet()
      common g(30,30), v(30,30), ib(30), jb(30), na, nb, np, nh

c     Ă錴q̑g C܂͋󔒂ŋ؂ē͂Ă'

       do 10 k = 1, nb
        read(*,*) ib(k), jb(k)
        g(ib(k),jb(k)) = 1.0
        g(jb(k),ib(k)) = 1.0
   10 continue
      return
      end

      subroutine hetero()
      common g(30,30), v(30,30), ib(30), jb(30), na, nb, np, nh

c     ύXsvf̔ԍƗvfiweEp[^j
c     @C܂͋󔒂ŋ؂ē͂ĂB

      do 10 k = 1, nh
        read(*,*) i,j,t
        g(i,j) = t
        g(j,i) = t
   10 continue

      return
      end
c
      subroutine diag()
      common g(30,30), v(30,30), ib(30), jb(30), na, nb, np, nh

c     Rr@ɂs̑Ίp

      it = 0
      dl = 0.000001
      do 10 i = 1, na
        v(i,i) = 1.0
   10 continue

    1 d = abs(g(2,1))
      do 20 i=2, na
        do 30 j=1, i-1
            if (abs(g(i,j)).gt.d) then
              d = abs(g(i,j))
            end if
   30   continue
   20 continue
   
      if (d.le.dl) go to 999
      
      sm = 0.1*d
      it = it + 1

c     write(*,'(I2,F12.7)') it, d

      do 40 j = 2, na
        do 50 k = 1, j-1
          if (abs(g(j,k)).le.sm) go to 50
          gj = g(j,j)
          gk = g(k,k)
          tb = (gj-gk)/(2*g(k,j))
          if (tb.le.0) then
            ta = tb-sqrt(1+tb*tb)
          else
           ta = tb+sqrt(1.0+tb*tb)
          end if
          cs = 1.0/sqrt(1.0+ta*ta)
          sn = cs*ta
          do 60 l=1, na
            if (l.eq.k) then
              g(k,k) = gk*cs*cs+g(j,k)*2*sn*cs+gj*sn*sn
              g(j,j) = gk+gj-g(k,k)
            else if (l.ne.j) then
              gkl = g(k,l)
              gjl = g(j,l)
              g(k,l) = gkl*cs+gjl*sn
              g(j,l) = gjl*cs-gkl*sn
              g(l,k)  =g(k,l)
              g(l,j) = g(j,l)
            end if
   60    continue
         g(j,k) = g(j,k)*(cs*cs-sn*sn)+(gj-gk)*sn*cs
         g(k,j) = g(j,k)
         do 70 i=1, na
           vj = v(i,j)
           vk = v(i,k)
           v(i,j)  =vj*cs-vk*sn
           v(i,k) = vj*sn+vk*cs
   70    continue
   50   continue
   40 continue
      go to 1

  999 return
      end
c
      subroutine incre()
      
c      ŗLxNgŗLl̏ɕׂ

      common g(30,30), v(30,30), ib(30), jb(30), na, nb, np, nh

      do 10 i=1, na
        emax = g(i,i)
        imax = i
        
        do 20 j=i, na
          if (g(j,j).gt.emax) then
            imax = j
            emax = g(j,j)
          end if
   20   continue
   
        if (i.lt.imax) then
          t = g(i,i)
          g(i,i) = g(imax,imax)
          g(imax,imax) = t
          do 30 j=1, na
            t = v(j,i)
            v(j,i) = v(j,imax)
            v(j,imax) = t
   30     continue
        end if
        
   10 continue

      return
      end
c
      subroutine pout()
      
      common g(30,30), v(30,30), ib(30), jb(30), na, nb, np, nh
c 
      write(*,100)
      k = 1
      j = 8
    1 if (j.gt.na) then
        j = na
      end if
      write(*,'(2X,8F9.4)') (g(i,i),i = k, j)
      write(*,'(1X)')
      call matout(k,j)
      k = j + 1
      j = k + 7
      if (k.le.na) goto 1
  100 format(/' -- Eigenvalues and Eigenvectors --'/)

      return
      end
c
      subroutine matout(k,j)
      common g(30,30), v(30,30), ib(30), jb(30), na, nb, np, nh

      do 10 i = 1, na
        write(*,'(I2,8F9.4)') i,( v(i,l),l=k,j)
   10 continue
      write(*,'(/)')

      return
      end
